#!/bin/sh
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library.  If not, see
# <http://www.gnu.org/licenses/>.


set -e

case $1 in
  -h | --h | --he | --hel | --help)
    cat <<EOF
Usage:
  $0 XML-FILE [SCHEMA-NAME]
  $0 OPTION

Options:
  -h | --help        Display program help
  -V | --version     Display program version
EOF
    exit ;;
  -V | --v | --ve | --ver | --vers | --versi | --versio | --version)
    cat <<EOF
$0 (libvirt) 1.1.3
EOF
    exit ;;
  --) shift ;;
  -*)
    echo "$0: unrecognized option '$1'" >&2
    exit 1 ;;
esac

XMLFILE="$1"
TYPE="$2"

if [ -z "$XMLFILE" ]; then
  echo "syntax: $0 XMLFILE [TYPE]" >&2
  exit 1
fi

if [ ! -f "$XMLFILE" ]; then
  echo "$0: document $XMLFILE does not exist" >&2
  exit 2
fi

if [ -z "$TYPE" ]; then
  ROOT=`xmllint --stream --debug "$XMLFILE" 2>/dev/null | grep "^0 1 " | awk '{ print $3 }'`
  case "$ROOT" in
     *domainsnapshot*) # Must come first, since *domain* is a substring
        TYPE="domainsnapshot"
        ;;
     *domain*)
        TYPE="domain"
        ;;
     *network*)
        TYPE="network"
        ;;
     *pool*)
        TYPE="storagepool"
        ;;
     *volume*)
        TYPE="storagevol"
        ;;
     *capabilities*)
        TYPE="capability"
        ;;
     *device*)
        TYPE="nodedev"
        ;;
     *filter*)
        TYPE="nwfilter"
        ;;
     *secret*)
        TYPE="secret"
        ;;
     *interface*)
        TYPE="interface"
        ;;
     *)
       echo "$0: cannot determine schema type for $XMLFILE" >&2
       exit 3
  esac
fi

SCHEMA="/usr/local/share/libvirt/schemas/${TYPE}.rng"

if [ ! -f "$SCHEMA" ]; then
  echo "$0: schema $SCHEMA does not exist" >&2
  exit 4
fi

xmllint --noout --relaxng "$SCHEMA" "$XMLFILE"

exit

: <<=cut
=pod

=head1 NAME

  virt-xml-validate - validate libvirt XML files against a schema

=head1 SYNOPSIS

  virt-xml-validate XML-FILE [SCHEMA-NAME]
  virt-xml-validate OPTION

=head1 DESCRIPTION

Validates a libvirt XML for compliance with the published schema.
The first compulsory argument is the path to the XML file to be
validated. The optional second argument is the name of the schema
to validate against. If omitted, the schema name will be inferred
from the name of the root element in the XML document.

Valid schema names currently include

=over 4

=item C<domainsnapshot>

The schema for the XML format used by domain snapshot configuration

=item C<domain>

The schema for the XML format used by guest domains configuration

=item C<network>

The schema for the XML format used by virtual network configuration

=item C<storagepool>

The schema for the XML format used by storage pool configuration

=item C<storagevol>

The schema for the XML format used by storage volume descriptions

=item C<nodedev>

The schema for the XML format used by node device descriptions

=item C<capability>

The schema for the XML format used to declare driver capabilities

=item C<nwfilter>

The schema for the XML format used by network traffic filters

=item C<secret>

The schema for the XML format used by secrets descriptions

=item C<interface>

The schema for the XML format used by physical host interfaces

=back

=head1 OPTIONS

=over

=item B<-h, --help>

Display command line help usage then exit.

=item B<-V, --version>

Display version information then exit.

=back

=head1 EXIT STATUS

Upon successful validation, an exit status of 0 will be set. Upon
failure a non-zero status will be set.

=head1 AUTHOR

Daniel P.Berrange

=head1 BUGS

Report any bugs discovered to the libvirt community via the
mailing list C<http://libvirt.org/contact.html> or bug tracker C<http://libvirt.org/bugs.html>.
Alternatively report bugs to your software distributor / vendor.

=head1 COPYRIGHT

Copyright (C) 2009-2013 by Red Hat, Inc.
Copyright (C) 2009 by Daniel P. Berrange

=head1 LICENSE

virt-xml-validate is distributed under the terms of the GNU GPL v2+.
This is free software; see the source for copying conditions. There
is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE

=head1 SEE ALSO

C<virsh(1)>, online XML format descriptions C<http://libvirt.org/format.html>

=cut
